<template>
  <div class="cta-album-rating">
    <h3 class="trunk heading--lg spacer--top">
      {{ $t('cta.album-rating.title') }}
    </h3>
    <div class="trunk products-rating spacer--bottom">
      <div
        v-for="(album, index) in data.items"
        :key="album.albumId"
        class="product product-rating"
      >
        <a :href="album.url" @click.prevent="albumClick(album, index + 1)">
          <img
            :src="album.coverUrl"
            :alt="album.albumTitle"
            class="product_image responsively-lazy"
            style="max-height: 420px"
          />
        </a>
        <RatingClick :album-id="album.albumId" />
      </div>
    </div>
  </div>
</template>

<script>
import RatingClick from '@/components/ui/RatingClick'

export default {
  name: 'CtaAlbumRatingSection',
  components: {
    RatingClick
  },
  props: {
    data: {
      type: Object,
      required: true
    }
  },

  mounted() {
    this.updateGtmData()
  },

  methods: {
    updateGtmData() {
      if (process.client) {
        // push album impression events
        if (this.data.items) {
          const impressions = []

          this.data.items.forEach((album, ind) => {
            impressions.push(
              this.$utils.gtmAdvEcommerceCreateProductImpression(
                album.albumTitle,
                album.albumId,
                '',
                '',
                'Album',
                this.$t('cta.album-rating.title'),
                ind + 1
              )
            )
          })

          if (impressions.length) {
            this.$utils.gtmAdvEcommercePushProductImpressions(impressions)
          }
        }
      }
    },

    albumClick(album, position) {
      const product = this.$utils.gtmAdvEcommerceCreateImpressionClickProduct(
        album.albumTitle,
        album.albumId,
        '',
        '',
        'Album',
        position
      )
      const e = this.$utils.gtmAdvEcommerceCreateProductClickEvent(
        product,
        this.$t('cta.album-rating.title')
      )
      this.$utils.gtmEvent(e, album.url)
    }
  }
}
</script>

<style lang="scss" scoped>
.cta-album-rating {
  .products-rating {
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    align-items: baseline;
    flex-wrap: wrap;
    @include screen-size(xl) {
      justify-content: left;
      flex-wrap: nowrap;
      width: 100%;
      max-width: none;
      white-space: nowrap;
      @include overflowScroll();
    }
  }

  .product-rating {
    max-width: 274px;

    .product_image {
      margin-bottom: 45px;
    }

    @include screen-size(xl) {
      .product_image {
        margin-bottom: 25px;
      }
    }

    @include screen-size(md) {
      + .product {
        margin-left: 10px;
      }
    }
  }
}
</style>
